package org.jboss.qe.cxf.ws.jms.jms;

import org.jboss.qe.cxf.ws.jms.GreetingService;

import org.junit.Assert;
import org.junit.Test;

import lombok.extern.slf4j.Slf4j;

@Slf4j
public class SoapJmsTest extends AbstractSoapJmsTest {

	@Test
	public void testQueue() throws Exception {
		final GreetingService service = getWebServiceProxy(GreetingService.class, "JMSQueueGreetingService", "JMSQueueGreetingPort", createConnectionFactoryFeature());
		final String response = service.greet(REQUEST);
		Assert.assertEquals(String.format(RESPONSE_TEMPLATE, REQUEST, "queue"), response);
	}

	@Test
	public void testTopic() throws Exception {
		final GreetingService service = getWebServiceProxy(GreetingService.class, "JMSTopicGreetingService", "JMSTopicGreetingPort", createConnectionFactoryFeature());
		final String response = service.greet(REQUEST);
		Assert.assertEquals(String.format(RESPONSE_TEMPLATE, REQUEST, "topic"), response);
	}

	@Test
	public void testJndi() throws Exception {
		final GreetingService service = getWebServiceProxy(GreetingService.class, "JMSJndiGreetingService", "JMSJndiGreetingPort", createConnectionFactoryFeature());
		final String response = service.greet(REQUEST);
		Assert.assertEquals(String.format(RESPONSE_TEMPLATE, REQUEST, "jndi"), response);
	}

	@Test
	public void testJndiTopic() throws Exception {
		final GreetingService service = getWebServiceProxy(GreetingService.class, "JMSJndiTopicGreetingService", "JMSJndiTopicGreetingPort", createConnectionFactoryFeature());
		final String response = service.greet(REQUEST);
		Assert.assertEquals(String.format(RESPONSE_TEMPLATE, REQUEST, "jndi-topic"), response);
	}
}
